#include <gtk/gtk.h>

static void activate (GtkApplication *app, gpointer user_data)
{
  GtkWidget *window = gtk_application_window_new (app);
  gtk_window_set_title (GTK_WINDOW (window), "Hello");
  GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
  gtk_window_set_child (GTK_WINDOW (window), vbox);
  GtkWidget *label = gtk_label_new ("Hello, world!");
  gtk_widget_set_margin_start (label, 15);
  gtk_widget_set_margin_end (label, 15);
  gtk_widget_set_margin_top (label, 10);
  gtk_box_append (GTK_BOX (vbox), label);
  GtkWidget *button = gtk_button_new_with_label ("Quit");
  gtk_widget_set_margin_start (button, 5);
  gtk_widget_set_margin_end (button, 5);
  gtk_widget_set_margin_top (button, 5);
  gtk_widget_set_margin_bottom (button, 5);
  g_signal_connect_swapped (button, "clicked", G_CALLBACK (gtk_window_destroy), window);
  gtk_box_append (GTK_BOX (vbox), button);
  gtk_window_present (GTK_WINDOW (window));
}

int main (int argc, char **argv)
{
  GtkApplication *app = gtk_application_new ("de.hs-bochum.cvh.hp.hello-gtk", G_APPLICATION_DEFAULT_FLAGS);
  g_signal_connect (app, "activate", G_CALLBACK (activate), NULL);
  int status = g_application_run (G_APPLICATION (app), argc, argv);
  g_object_unref (app);
  return status;
}
