#include <gtk/gtk.h>

static void hello (GtkWidget *this, gpointer user_data)
{
  char *world = user_data;
  printf ("Hello, %s!\n", world);
}

static void activate (GtkApplication *app, gpointer user_data)
{
  GtkWidget *window = gtk_application_window_new (app);
  gtk_window_set_title (GTK_WINDOW (window), "Hello");

  GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
  gtk_window_set_child (GTK_WINDOW (window), vbox);

  GtkWidget *hello_button = gtk_button_new_with_label ("Hello, world!");
  g_signal_connect (hello_button, "clicked", G_CALLBACK (hello), "world");
  gtk_box_append (GTK_BOX (vbox), hello_button);

  GtkWidget *quit_button = gtk_button_new_with_label ("Quit");
  g_signal_connect_swapped (quit_button, "clicked", G_CALLBACK (gtk_window_destroy), window);
  gtk_box_append (GTK_BOX (vbox), quit_button);

  gtk_window_present (GTK_WINDOW (window));
}

int main (int argc, char **argv)
{
  GtkApplication *app = gtk_application_new ("de.hs-bochum.cvh.hp.hello-gtk", G_APPLICATION_DEFAULT_FLAGS);
  g_signal_connect (app, "activate", G_CALLBACK (activate), NULL);
  int status = g_application_run (G_APPLICATION (app), argc, argv);
  g_object_unref (app);
  return status;
}
