#include <gtk/gtk.h>

static void draw (GtkDrawingArea *drawing_area, cairo_t *c,
                  int width, int height, gpointer user_data)
{
  printf ("draw()\n");

  GdkRGBA red = { 1.0, 0.0, 0.0, 0.8 };
  GdkRGBA yellow = { 1.0, 1.0, 0.0, 0.6 };
  GdkRGBA blue = { 0.0, 0.5, 1.0, 0.4 };

  gdk_cairo_set_source_rgba (c, &red);
  cairo_rectangle (c, 10, 10, 60, 40);
  cairo_fill (c);

  gdk_cairo_set_source_rgba (c, &yellow);
  cairo_arc (c, 65, 50, 30, 0, 2 * G_PI);
  cairo_fill (c);

  gdk_cairo_set_source_rgba (c, &blue);
  cairo_move_to (c, 10, 70);
  cairo_line_to (c, 70, 70);
  cairo_line_to (c, 40, 18);
  cairo_close_path (c);
  cairo_fill (c);
}

static void activate (GtkApplication *app, gpointer user_data)
{
  GtkWidget *window = gtk_application_window_new (app);
  gtk_window_set_title (GTK_WINDOW (window), "Hello");

  GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
  gtk_window_set_child (GTK_WINDOW (window), vbox);

  GtkWidget *drawing_area = gtk_drawing_area_new ();
  gtk_widget_set_size_request (drawing_area, 100, 100);
  gtk_drawing_area_set_draw_func (GTK_DRAWING_AREA (drawing_area), draw, NULL, NULL);
  gtk_box_append (GTK_BOX (vbox), drawing_area);

  GtkWidget *quit_button = gtk_button_new_with_label ("Quit");
  g_signal_connect_swapped (quit_button, "clicked", G_CALLBACK (gtk_window_destroy), window);
  gtk_box_append (GTK_BOX (vbox), quit_button);

  gtk_window_present (GTK_WINDOW (window));
}

int main (int argc, char **argv)
{
  GtkApplication *app = gtk_application_new ("de.hs-bochum.cvh.hp.hello-gtk", G_APPLICATION_DEFAULT_FLAGS);
  g_signal_connect (app, "activate", G_CALLBACK (activate), NULL);
  int status = g_application_run (G_APPLICATION (app), argc, argv);
  g_object_unref (app);
  return status;
}
