#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>

#define F_CPU 16000000l
#include <util/delay.h>

volatile uint8_t key_pressed = 0;

ISR (INT0_vect)  /* PD2 */
{
  key_pressed = 1;
}

int main (void)
{
  cli ();
  EICRA = 1 << ISC00 | 1 << ISC01;  /* INT0: steigende Flanke */
  EIMSK = 1 << INT0;  /* INT0 einschalten */
  sei ();
  DDRD = 0xfb;   /* binär: 1111 1011 */
  PORTD = 0x41;  /* binär: 0100 0001 */
  while (1)
    {
      while (!key_pressed)
        ;  /* just wait */
      PORTD ^= 0x40;
      _delay_ms (1);  /* Wartezeit zum Entprellen */
      key_pressed = 0;
    }
  return 0;
}
