#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int comparisons = 0;

void display (char **name, int left, int right)
{
  printf ("\e[H\e[J");
  for (int i = 0; name[i]; i++)
    {
      printf ("%s", name[i]);
      if (i == left || i == right)
        printf (" <--");
      printf ("\n");
    }
  printf ("%d\n", comparisons);
}

int compare (char **name, int left, int right)
{
  int result = strcmp (name[left], name[right]);
  comparisons++;
  display (name, left, right);
  usleep (200000);
  return result;
}

int is_sorted (char **name)
{
  for (int i = 1; name[i]; i++)
    if (compare (name, i - 1, i) > 0)
      return 0;
  return 1;
}

void mix (char **name)
{
  int n = 0;
  while (name[n])
    n++;
  for (int i = 0; i < n; i++)
    {
      int j = rand () % (n - i);
      char *temp = name[i];
      name[i] = name[j];
      name[j] = temp;
    }
}

void sort (char **name)
{
  while (!is_sorted (name))
    mix (name);
}

int main (void)
{
  char *name[] = { "Otto", "Lisa", "Anna", "Heinrich", "Siegfried", "Peter",
                   "Dieter", "Hugo", "Berta", "Maria", "Fritz", "Box", "Hans",
                   "Thomas", "Ulrich", "Zacharias", NULL };
  sort (name);
  display (name, -1, -1);
  return 0;
}
