#include <stdio.h>
#include <stdint.h>

uint8_t buffer = 0;

void bit_array_set (int i, int value)
{
  uint8_t mask = 1 << i;
  if (value)
    buffer |= mask;
  else
    buffer &= ~mask;
}

void bit_array_flip (int i)
{
  uint8_t mask = 1 << i;
  buffer ^= mask;
}

int bit_array_get (int i)
{
  uint8_t mask = 1 << i;
  if (buffer & mask)
    return 1;
  else
    return 0;
}

void output (void)
{
  for (int i = 0; i < 8; i++)
    {
      if (i % 4 == 0)
        printf (" ");
      printf ("%d", bit_array_get (i));
    }
  printf ("\n");
}

int main (void)
{
  output ();
  bit_array_set (2, 1);
  output ();
  bit_array_flip (7);
  output ();
  bit_array_set (2, 0);
  output ();
}
