#include <stdio.h>
#include <stdint.h>

#define LENGTH 32

uint8_t buffer[LENGTH / 8] = { 0, 0, 0, 0 };

void bit_array_set (int i, int value)
{
  int byte_index = i / 8;
  int bit_index = i % 8;
  uint8_t mask = 1 << bit_index;
  if (value)
    buffer[byte_index] |= mask;
  else
    buffer[byte_index] &= ~mask;
}

void bit_array_flip (int i)
{
  int byte_index = i / 8;
  int bit_index = i % 8;
  uint8_t mask = 1 << bit_index;
  buffer[byte_index] ^= mask;
}

int bit_array_get (int i)
{
  int byte_index = i / 8;
  int bit_index = i % 8;
  uint8_t mask = 1 << bit_index;
  if (buffer[byte_index] & mask)
    return 1;
  else
    return 0;
}

void output (void)
{
  for (int i = 0; i < LENGTH; i++)
    {
      if (i % 4 == 0)
        printf (" ");
      printf ("%d", bit_array_get (i));
    }
  printf ("\n");
}

int main (void)
{
  output ();
  bit_array_set (12, 1);
  output ();
  bit_array_flip (31);
  output ();
  bit_array_set (12, 0);
  output ();
}
