#include <stdio.h>

#define STACK_SIZE 10

int stack[STACK_SIZE];
int stack_pointer = 0;

void push (int x)
{
  stack[stack_pointer++] = x;
}

int pop (void)
{
  return stack[--stack_pointer];
}

void show (void)
{
  printf ("stack content:");
  for (int i = 0; i < stack_pointer; i++)
    printf (" %d", stack[i]);
  if (stack_pointer)
    printf ("\n");
  else
    printf (" (empty)\n");
}

void insert (int x, int pos)
{
  for (int i = stack_pointer - 1; i >= pos; i--)
    stack[i + 1] = stack[i];
  stack[pos] = x;
  stack_pointer++;
}

void insert_sorted (int x)
{
  int i = stack_pointer - 1;
  while (i >= 0 && x < stack[i])
    i--;
  insert (x, i + 1);
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  show ();
  insert (5, 1);
  show ();
  insert_sorted (42);
  show ();
  insert_sorted (2);
  show ();
  return 0;
}
