#include <stdio.h>

#define STACK_SIZE 10

int stack[STACK_SIZE];
int stack_pointer = 0;

void push (int x)
{
  stack[stack_pointer++] = x;
}

int pop (void)
{
  return stack[--stack_pointer];
}

void show (void)
{
  printf ("stack content:");
  for (int i = 0; i < stack_pointer; i++)
    printf (" %d", stack[i]);
  if (stack_pointer)
    printf ("\n");
  else
    printf (" (empty)\n");
}

void insert (int x, int pos)
{
  for (int i = stack_pointer - 1; i >= pos; i--)
    stack[i + 1] = stack[i];
  stack[pos] = x;
  stack_pointer++;
}

void insert_sorted (int x)
{
  int i = stack_pointer - 1;
  while (i >= 0 && x < stack[i])
    {
      stack[i + 1] = stack[i];
      i--;
    }
  stack[i + 1] = x;
  stack_pointer++;
}

int search (int x)
{
  int left = 0;
  int right = stack_pointer;
  while (left < right - 1)
    {
      int middle = (left + right) / 2;
      if (x < stack[middle])
        right = middle;
      else
        left = middle;
    }
  if (x == stack[left])
    return left;
  else
   return -1;
}

int main (void)
{
  push (3);
  push (7);
  push (137);
  show ();
  insert (5, 1);
  show ();
  insert_sorted (42);
  show ();
  insert_sorted (2);
  show ();
  printf ("%d\n", search (2));
  printf ("%d\n", search (4));
  printf ("%d\n", search (42));
  printf ("%d\n", search (67));
  printf ("%d\n", search (137));
  printf ("%d\n", search (1117));
  return 0;
}
