#include <stdio.h>
#include <string.h>

void insert_into_string (char src, char *target, int pos) {
  // Bestimme die Länge des Strings target
  int len = strlen(target);

  // Verschiebe alle Zeichen des Strings ab der Stelle pos um eine Stelle nach rechts
  for (int i = len; i > pos; i--) {
    target[i] = target[i-1];
  }

  // Füge das Zeichen src an der Stelle pos ein
  target[pos] = src;
}

void insert_into_string_sorted (char src, char *target) {
  // Bestimme die Länge des Strings target
  int len = strlen(target);

  // Setze die Grenzen für die binäre Suche auf das erste und letzte Zeichen des Strings
  int left = 0;
  int right = len - 1;

  // Führe die binäre Suche durch, bis left und right auf dasselbe Zeichen zeigen
  while (left < right) {  // Bestimme die Mitte des aktuellen Suchbereichs
    int mid = (left + right) / 2;

    // Wenn src alphabetisch vor dem aktuellen Zeichen liegt, suche im linken Teilbereich weiter
    if (src < target[mid]) {
      right = mid;
    }
    // Wenn src alphabetisch hinter dem aktuellen Zeichen liegt, suche im rechten Teilbereich weiter
    else {
      left = mid + 1;
    }
  }

  // Füge src an der Stelle left in den String ein
  insert_into_string(src, target, left);
}

int main (void)
{
  char test[100] = "";
  insert_into_string_sorted ('c', test);
  insert_into_string_sorted ('a', test);
  insert_into_string_sorted ('d', test);
  insert_into_string_sorted ('b', test);
  printf ("%s\n", test);
  return 0;
}
