#include <gtk/gtk.h>

#define WIDTH 320
#define HEIGHT 240

double t = 0.0;
double dt = 0.2;

int r = 5;

double x = 10;
double y = 200;
double vx = 20;
double vy = -60;
double g = 9.81;

gboolean draw (GtkWidget *widget, cairo_t *c, gpointer data)
{
  GdkRGBA blue = { 0.0, 0.5, 1.0, 1.0 };

  gdk_cairo_set_source_rgba (c, &blue);
  cairo_arc (c, x, y, r, 0, 2 * G_PI);
  cairo_fill (c);

  return FALSE;
}

gboolean timer (GtkWidget *widget)
{
  t += dt;
  x += vx * dt;
  y += vy * dt;
  vx = vx;
  vy = 0.5 * g * (t * t);
  if (y + r >= HEIGHT)
    vy = -vy * 0.9;
  if (x + r >= WIDTH)
    vx = -vx * 0.9;
  if (x - r <= 0)
    vx = -vx * 0.9;
  gtk_widget_queue_draw_area (widget, 0, 0, WIDTH, HEIGHT);
  g_timeout_add (50, (GSourceFunc) timer, widget);
  return FALSE;
}

int main (int argc, char **argv)
{
  gtk_init (&argc, &argv);

  GtkWidget *window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_show (window);
  gtk_window_set_title (GTK_WINDOW (window), "Hello");
  g_signal_connect (window, "destroy", G_CALLBACK (gtk_main_quit), NULL);

  GtkWidget *drawing_area = gtk_drawing_area_new ();
  gtk_widget_show (drawing_area);
  gtk_container_add (GTK_CONTAINER (window), drawing_area);
  gtk_widget_set_size_request (drawing_area, WIDTH, HEIGHT);

  gtk_main ();
  return 0;
}
