Hardwarenahe Programmierung
===========================

Lehrveranstaltung im Wintersemester 2023/24  
Hochschule Bochum, Campus Velbert/Heiligenhaus  
Prof. Dr. rer. nat. Peter Gerwinski

Copyright © 2012–2023  Peter Gerwinski

**Diese Lehrmaterialien sind freie Software.**  
Sie dürfen diese gemäß den jeweils angegebenen Lizenzen  
([CC-BY-SA 3.0](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/CC-BY-SA-3.0),
[GNU GPL 3+](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/GNU-GPL-3),
[modified BSD License](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/BSD-MODIFIED))  
studieren, kopieren, modifizieren und/oder weitergeben.  
Für Details siehe [common/README](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/README).

Vortragsfolien und Beispiele:
-----------------------------
 * [05.10.2023: Einführung, Einführung in C (bis 2.7: Strukturierte Programmierung)](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231005/hp-20231005.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231005/)
 * [12.10.2023: Einführung in C (ab 2.8: Seiteneffekte)](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231012/hp-20231012.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231012/)
 * [19.10.2023: Einführung in C (ab 2.11: Arrays und Strings)](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231019/hp-20231019.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231019/)
 * [26.10.2023: Einführung in C: String-Operationen; Bibliotheken](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231026/hp-20231026.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231026/)
 * [02.11.2023: Bibliotheken](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231102/hp-20231102.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231102/)
 * [09.11.2023: Hardwarenahe Programmierung](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231109/hp-20231109.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231109/)
 * [16.11.2023: Byte-Reihenfolge, Darstellung negativer Zahlen, Darstellung von Gleitkommazahlen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231116/hp-20231116.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231116/)
 * [23.11.2023: Speicherausrichtung, Algorithmen: Differentialgleichungen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231123/hp-20231123.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231123/)
 * [30.11.2023: Algorithmen: Rekursion](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231130/hp-20231130.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231130/)
 * [07.12.2023: Algorithmen: Aufwandsabschätzungen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231207/hp-20231207.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231207/)
 * [14.12.2023: Objektorientierte Programmierung](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231214/hp-20231214.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20231214/)
 * [04.01.2024: Dunkle Materie und angewandte hardwarenahe Programmierung](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240104/hp-20240104.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20240104/)
 * [11.01.2024: Datenstrukturen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240111/hp-20240111.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20240111/)
 * [18.01.2024: Datenstrukturen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240118/hp-20240118.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/20240118/)
 * [alle in 1 Datei](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/hp-slides-2023ws.pdf)

Übungsaufgaben:
---------------
 * [05.10.2023: Hello-World-Programme, Schaltjahr ermitteln, Maximum berechnen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231005/hp-uebung-20231005.pdf)
 * [12.10.2023: Schaltjahr ermitteln, Multiplikationstabelle, Fibonacci-Zahlen, fehlerhaftes Programm](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231012/hp-uebung-20231012.pdf)
 * [19.10.2023: Seltsame Programme, Kalender-Berechnung, Strings, Programm analysieren](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231019/hp-uebung-20231019.pdf)
 * [26.10.2023: Arrays mit Zahlen, Datum-Bibliothek, fehlerhaftes Primzahl-Programm](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231026/hp-uebung-20231026.pdf)
 * [02.11.2023: Zahlensysteme, Ausgabe von Hexadezimalzahlen, Einfügen in Strings](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231102/hp-uebung-20231102.pdf)
 * [09.11.2023: Text-Grafik-Bibliothek, Mikrocontroller, LED-Blinkmuster](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231109/hp-uebung-20231109.pdf)
 * [16.11.2023: Trickprogrammierung, Thermometer-Baustein an I²C-Bus, Speicherformate von Zahlen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231116/hp-uebung-20231116.pdf)
 * [23.11.2023: Kondensator, Personen-Datenbank, Hexdumps](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231123/hp-uebung-20231123.pdf)
 * [30.11.2023: PBM-Grafik, Fakultät](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231130/hp-uebung-20231130.pdf)
 * [07.12.2023: Länge von Strings, Einfügen in Strings (Ergänzung)](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231207/hp-uebung-20231207.pdf)
 * [14.12.2023: dynamisches Bit-Array, objektorientierte Tier-Datenbank](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231214/hp-uebung-20231214.pdf)
 * [11.01.2024: Objektorientierte Tier-Datenbank (Ergänzung), Iterationsfunktionen, Stack-Operationen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240111/hp-uebung-20240111.pdf)
 * [18.01.2024: Einfach und doppelt verkettete Listen, ternärer Baum, hüpfender Ball](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240118/hp-uebung-20240118.pdf)

Musterlösungen:
---------------
 * [12.10.2023: Schaltjahr ermitteln, Multiplikationstabelle, Fibonacci-Zahlen, fehlerhaftes Programm](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231012/hp-musterloesung-20231012.pdf)
 * [19.10.2023: Seltsame Programme, Kalender-Berechnung, Strings, Programm analysieren](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231019/hp-musterloesung-20231019.pdf)
 * [26.10.2023: Arrays mit Zahlen, Datum-Bibliothek, fehlerhaftes Primzahl-Programm](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231026/hp-musterloesung-20231026.pdf)
 * [02.11.2023: Zahlensysteme, Ausgabe von Hexadezimalzahlen, Einfügen in Strings](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231102/hp-musterloesung-20231102.pdf)
 * [09.11.2023: Text-Grafik-Bibliothek, Mikrocontroller, LED-Blinkmuster](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231109/hp-musterloesung-20231109.pdf)
 * [16.11.2023: Trickprogrammierung, Thermometer-Baustein an I²C-Bus, Speicherformate von Zahlen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231116/hp-musterloesung-20231116.pdf)
 * [23.11.2023: Kondensator, Personen-Datenbank, Hexdumps](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231123/hp-musterloesung-20231123.pdf)
 * [30.11.2023: PBM-Grafik, Fakultät](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231130/hp-musterloesung-20231130.pdf)
 * [07.12.2023: Länge von Strings, Einfügen in Strings (Ergänzung)](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231207/hp-musterloesung-20231207.pdf)
 * [14.12.2023: dynamisches Bit-Array, objektorientierte Tier-Datenbank](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231214/hp-musterloesung-20231214.pdf)
 * [11.01.2024: Objektorientierte Tier-Datenbank (Ergänzung), Iterationsfunktionen, Stack-Operationen](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240111/hp-musterloesung-20240111.pdf)
 * [18.01.2024: Einfach und doppelt verkettete Listen, ternärer Baum, hüpfender Ball](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20240118/hp-musterloesung-20240118.pdf)

Praktikumsunterlagen:
---------------------
 * [Versuch 1: RSA-Verschlüsselung](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231012/hp-2023ws-p1.pdf)
 * [Versuch 2: Druckknopfampel](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/20231109/hp-2023ws-p2.pdf)

Alte Klausuren:
---------------
 * [Wintersemester 2015/16](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/exams/20160129/ainf-klausur-20160129.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/exams/20160129/)
 * [Wintersemester 2016/17](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/exams/20170206/hp-klausur-20170206.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/exams/20170206/)
 * [Wintersemester 2017/18](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/exams/20180213/hp-klausur-20180213.pdf) [**(Beispiele)**](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/exams/20180213/)

Skript:
-------
 * [Hardwarenahe Programmierung](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/script/hp-2023ws.pdf)

Original-Materialien einschließlich Beispiel-Programme und LaTeX-Quelltexte:
----------------------------------------------------------------------------
 * [common – gemeinsame Dateien für Skript und Vortragsfolien](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/common)
 * [script – Skript zur Lehrveranstaltung](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/script)
 * [202????? – Vortragsfolien und Beispiele](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws)
 * [branch 2022ws – vollständige Lehrmaterialien vom Wintersemester 2022/23](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2022ws)


Low-Level Programming
=====================

Course in winter semester 2023-24
Bochum University of Applied Sciences, Campus Velbert/Heiligenhaus  
Prof. Dr. rer. nat. Peter Gerwinski

Copyright © 2012–2023  Peter Gerwinski

**These teaching materials are Free Software.**  
You may study, copy, modify, and/or distribute them  
according to their respective licences  
([CC-BY-SA 3.0](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/CC-BY-SA-3.0),
[GNU GPL 3+](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/GNU-GPL-3),
[modified BSD License](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/BSD-MODIFIED)).  
See the file [common/README](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/common/README) for details.

 * [common – common files for lecture notes and slides](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/common)
 * [script – lecture notes](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws/script)
 * [202????? – slides and examples](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2023ws)
 * [hp-slides-2023ws.pdf – all slides in 1 file](https://gitlab.cvh-server.de/pgerwinski/hp/raw/2023ws/hp-slides-2023ws.pdf)
 * [branch 2022ws – complete teaching materials from winter semester 2022-23](https://gitlab.cvh-server.de/pgerwinski/hp/tree/2022ws)
