#include <stdio.h>
#include <stdint.h>
#include <errno.h>
#include <error.h>

/* Die Aufgabe besteht darin, die Funktionen pbm_open(),
 * pbm_line() und pbm_close() zu schreiben.
 */

int pbm_width = 0;
int pbm_height = 0;
FILE *pbm_file;  /* globale Variable für die PBM-Datei */

void pbm_open (int width, int height, char *filename)
{
  pbm_file = fopen (filename, "w");
  if (!pbm_file)
    error (errno, errno, "cannot open file %s for writing", filename);
  pbm_width = width;
  pbm_height = height;
  fprintf (pbm_file, "P4\n%d %d\n", pbm_width, pbm_height);
}

void pbm_line (char *line)
{
  int pbm_bytes = (pbm_width + 7) / 8;   /* benötigte Bytes pro Zeile (immer aufrunden) */
  uint8_t buffer[pbm_bytes];
  for (int i = 0; i < pbm_bytes; i++)   /* Puffer auf 0 initialisieren */
    buffer[i] = 0;
  for (int x = 0; line[x]; x++)
    {
      int i = x / 8;  /* In welches Byte des Puffers gehört dieses Pixel? */
      int b = x % 8;  /* Welches Bit innerhalb des Bytes ist dieses Pixel? */
      if (line[x] != ' ')   /* Kein Leerzeichen --> Bit auf 1 setzen */
        buffer[i] |= 1 << b;
    }
  for (int i = 0; i < pbm_bytes; i++)   /* Puffer in Datei ausgeben */
    fprintf (pbm_file, "%c", buffer[i]);
}

void pbm_close (void)
{
  fclose (pbm_file);
}

int main (void)
{
  pbm_open (14, 14, "test.pbm");
  pbm_line ("              ");
  pbm_line ("    XXXXXX    ");
  pbm_line ("   X      X   ");
  pbm_line ("  X        X  ");
  pbm_line (" X          X ");
  pbm_line (" X  XX  XX  X ");
  pbm_line (" X   X   X  X ");
  pbm_line (" X          X ");
  pbm_line (" X X      X X ");
  pbm_line (" X  X    X  X ");
  pbm_line ("  X  XXXX  X  ");
  pbm_line ("   X      X   ");
  pbm_line ("    XXXXXX    ");
  pbm_line ("              ");
  pbm_close ();
  return 0;
}
